/*
 * This code is sample code, provided as-is, and we make no
 * warranties as to its correctness or suitablity for
 * any purpose.
 *
 * We hope that it's useful to you.  Enjoy.
 * Copyright 2004-11 LearningPatterns Inc.
 */

 package com.javatunes.beans;

//We need the com.javatunes.util package for SearchUtility and ItemValue
import com.javatunes.util.*;

//We need the java.util for List and ArrayList
import java.util.*;
import java.math.BigDecimal; // For cart total calculation

// JSF imports 
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
// TODO - Import the FacesContext/ExternalContext to get the parameter passed by the Add to Cart link
// TODO - For ActionListener lab, import ActionEvent
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

@ManagedBean(name = "cart")
@SessionScoped
public class CartBean {

	//This is the actual shopping cart
	private List<MusicItem> cartList = new ArrayList<MusicItem>();

	// These two properties are used in the action listener lab
	boolean showTotal = false;
	BigDecimal cartTotal = new BigDecimal("0.00");	

	//Just for debug purposes
	public CartBean()
	{
		System.out.println("We also have a CartBean...");
	}
	
	public List<MusicItem> getCartList()
	{
		return cartList;
	}
	public void setCartList(List<MusicItem> clist)
	{
		cartList = clist;
	}
	
	public boolean isShowTotal() {
		return showTotal;
	}

	public void setShowTotal(boolean showTotal) {
		this.showTotal = showTotal;
	}

	public BigDecimal getCartTotal() {
		return cartTotal;
	}

	public void setCartTotal(BigDecimal cartTotal) {
		this.cartTotal = cartTotal;
	}	
	
	public String add(){
	
		String outcome = "displayCart";

		// TODO Finish the code below to get the request paramater named "id"
		FacesContext ctx = FacesContext.getCurrentInstance();
		ExternalContext ec = ctx.getExternalContext();

		String theID = (String) ec.getRequestParameterMap().get("id");

		System.out.println("ID passed to add() method on the CartBean was: " + theID);

		MusicItem toAdd = (MusicItem) SearchUtility.findById(Long.valueOf(theID));

		cartList.add(toAdd);

		return outcome;
	}

	// TODO: Finish for actionListener Lab
	public void showTotal(/* Todo */) 
	{
		BigDecimal total = new BigDecimal ("0.00");

		for(MusicItem curItem : getCartList()) {
			BigDecimal price = curItem.getPrice();
			System.out.println("Adding price: " + price + ", to totalCost");
			total = total.add(price);
		}

		// TODO: Set showTotal and cartTotal properties
	}	
	

}

