/*
 * This code is sample code, provided as-is, and we make no
 * warranties as to its correctness or suitablity for
 * any purpose.
 *
 * We hope that it's useful to you.  Enjoy.
 * Copyright 2004-11 LearningPatterns Inc.
 */
package com.javatunes.beans;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

//We need the com.javatunes.util package for SearchUtility and ItemValue
import com.javatunes.util.*;
//We need the java.util for List and ArrayList
import java.util.*;

@ManagedBean(name = "search")
@SessionScoped
public class SearchBean {

    private String keyword = null;
    private List<MusicItem> searchList = null;
    private String artist = null;
    private float maxPrice = 24.99f;

    /** Creates a new instance of SearchBean */
    public SearchBean() {
        System.out.println("We have a SearchBean now...");
    }

    public void setKeyword(String key) {
        keyword = key;
        System.out.println("SearchBean setKeyword() was invoked with a value of: " + key);
    }

    public String getKeyword() {
        return keyword;
    }

    public void setSearchList(List<MusicItem> sl) {
        searchList = sl;
        System.out.println("SearchBean setSearchList() was invoked with a value of: " + sl);
    }

    public List<MusicItem> getSearchList() {
        return searchList;
    }
    
    public String getArtist() {
		return artist;
	}

	public void setArtist(String artist) {
		this.artist = artist;
	}

    public float getMaxPrice() {
        return maxPrice;
    }

    public void setMaxPrice(float maxPrice) {
        this.maxPrice = maxPrice;
    }
	
	// Getter method for search size
    public int getSearchSize() {
        return getSearchList() == null ? 0 : getSearchList().size();
    }

    //Return the String for Navigation to the next best view
    public String catSearch() {

        String nextBest = "/pages/searchResults.xhtml";
        String searchString = getKeyword();

        if (getArtist() != null) { // If there is an artist seelcted, then search on it.
            System.out.println("using artist");
            searchString = getArtist();
        }

        System.out.println("searchString = " + searchString);

        List<MusicItem> results = (List<MusicItem>) SearchUtility.findByKeyword(searchString, getMaxPrice());

        this.setSearchList(results);

        return nextBest;
    }
}
